open Common

module M (B : Backend.S) = struct
  type state = {rect_origin: Point.t; rect_v: Point.t}

  let initial_state = {rect_origin= (10, 10); rect_v= (1, 1)}

  let _ = B.init_audio ()

  let music = B.load_audio_file "../musicbox_silent_night.ogg"

  let _ = B.play_audio_loop music

  let boom = B.load_audio_file "../boom_bang.ogg"

  let curr_state = ref initial_state

  let rect_size = (50, 50)

  let update_state () =
    let s = !curr_state in
    let new_orig = Point.add s.rect_origin s.rect_v in
    let vx =
      if fst new_orig < 0 || fst new_orig + fst rect_size >= 800 then (
        B.play_audio_once boom ;
        -fst s.rect_v )
      else fst s.rect_v
    in
    let vy =
      if snd new_orig < 0 || snd new_orig + snd rect_size >= 600 then (
        B.play_audio_once boom ;
        -snd s.rect_v )
      else snd s.rect_v
    in
    curr_state := {rect_origin= new_orig; rect_v= (vx, vy)}

  let render ctx =
    B.begin_display ctx ;
    B.set_rgb_color ctx (0, 0, 0) ;
    B.clear ctx ;
    B.set_rgb_color ctx (60, 218, 35) ;
    B.draw_rect ctx !curr_state.rect_origin rect_size ;
    B.display ctx
end
