module type S = sig
  type t

  type audio_file

  val begin_display : t -> unit

  val clear : t -> unit

  val display : t -> unit

  val draw_line : t -> Point.t -> Point.t -> unit

  val draw_point : t -> Point.t -> unit

  val draw_rect : t -> Point.t -> Point.t -> unit

  val error : string -> 'a

  val fill_rect : t -> Point.t -> Point.t -> unit

  val init_audio : unit -> unit

  val load_audio_file : string -> audio_file

  val play_audio_loop : audio_file -> unit

  val play_audio_once : audio_file -> unit

  val set_rgb_color : t -> Color.rgb -> unit

  val set_rgba_color : t -> Color.rgba -> unit
end
