type t = int * int

let mk x y = (x, y)

let combine op (x1, y1) (x2, y2) = mk (op x1 x2) (op y1 y2)

let map f (x, y) = (f x, f y)

let add = combine ( + )

let sub = combine ( - )

let mul = combine ( * )

let div = combine ( / )

let distance p1 p2 =
  let x, y = sub p2 p1 in
  sqrt (float_of_int ((x * x) + (y * y)))

let to_float p = map float_of_int p
