module M (B : Common.Backend.S) = struct
  let run ctx =
    B.set_rgb_color ctx (0, 0, 0) ;
    B.clear ctx ;
    B.set_rgb_color ctx (60, 218, 35) ;
    B.draw_line ctx (25, 25) (50, 50) ;
    B.display ctx
end

let _ =
  let open Tsdl.Sdl in
  let aux big little = Int32.of_int (if Sys.big_endian then big else little) in
  let rmask = aux 0xff000000 0x000000ff in
  let gmask = aux 0x00ff0000 0x0000ff00 in
  let bmask = aux 0x0000ff00 0x00ff0000 in
  let amask = aux 0x000000ff 0xff000000 in
  let w, h = (800, 600) in
  let surface =
    match
      Tsdl.Sdl.create_rgb_surface ~w ~h ~depth:32 rmask gmask bmask amask
    with
    | Ok s ->
        s
    | _ ->
        failwith "can't create surface"
  in
  let rend =
    match create_software_renderer surface with
    | Ok r ->
        r
    | _ ->
        failwith "can't create renderer"
  in
  let module T = M (Sdl_backend.M) in
  let rend = Obj.magic rend in
  T.run rend ; ()
